/* *************************************************************************
   tv CLKB-0707 vO
   clock.c

   CCS PICCRpCŃRpC

   n[hEGA:
	}CR 	PIC16F877 fclk=32.768kHz 

	LCD\ 	4a	RB0	//  |
	  SP-521    @	4b	RB1	//  |
	  		4c	RB2	//  |
			4d	RB3	//  |  1̌
			4e	RB4	//  |
	  		4f	RB5	//  |
			4g	RB6	//  |
			common	RB7	// R  32.00000Hz
	  		3a	RC0	//  |
			3b	RC1	//  |
	  		3c	RC2	//  |
			3d	RC3	//  |  10̌
			3e	RC4	//  |
	  		3f	RC5	//  |
			3g	RC6	//  |
			colon 	RC7	// R
	  		2a	RD0	//  |
			2b	RD1	//  |
	  		2c	RD2	//  |
			2d	RD3	//  |  1̌
			2e	RD4	//  |
	  		2f	RD5	//  |
			2g	RD6	//  |
			1bc     RD7	// 10̌
			
	XCb` 	SW0	RA0	// [ANeBu
	 	    @	SW1	RA1	// [ANeBu
	ý߲	TP0	RA2	// Zp
	ړ_		RL0	RA3	// nCANeBu

								200706100152

   ************************************************************************* */
#if defined(__PCM__)
#include <16F877.h>

#include <stdlib.h>

// #device ICD=TRUE		// ıĂĂȂƓsɂȂ
#fuses LP,NOWDT,NOPROTECT,NOLVP,NOBROWNOUT
#use delay(clock=32768) 	// NbNݒ
#endif

#BYTE porta = 0x5		// |[g`AhX
#BYTE portb = 0x6		// |[gaAhX
#BYTE portc = 0x7		// |[gbAhX
#BYTE portd = 0x8		// |[gcAhX
#BYTE porte = 0x9		// |[gdAhX

#BYTE trisa = 0x85		// |[g`o͐ݒAhX
#BYTE trisb = 0x86		// |[gao͐ݒAhX
#BYTE trisc = 0x87		// |[gbo͐ݒAhX
#BYTE trisd = 0x88		// |[gco͐ݒAhX
#BYTE trise = 0x89		// |[gdo͐ݒAhX

#BYTE TMR0  = 0x01		// TMR0ݒAhX
#BYTE OPTION = 0x81		// OPTIONWX^̃AhX
#BYTE INTCON = 0x0b		// INTCONWX^̃AhX
#BYTE ADCON1 = 0x9f		// ADCON1WX^̃AhX

// -------- Ŏgp郌WX^ --------
int colond;			//         LCD ăf[^
int INT_COUNT;			// 1b邽߂̃JE^
int second;			// ݎ@b
int minute;			// ݎ@
int hour;			// ݎ@ 24Ԑœ
boolean ONE_SECOND_FLAG;	// 1bƂTRUEɾāBҲ݂ؾĂ邱
boolean COLON;			// ݂_łƂTRUEɾĂOK
int contact_time0;		// ړ_o͎0 24ȏoff
int contact_time1;		// ړ_o͎1 24ȏoff

// -------- tZOgf[^ --------
int digit0;			// 1̌  LCD ăf[^
int digit1;			// 10̌ LCD ăf[^
int digit2;			// 1̌  LCD ăf[^{10̌

// -------- n[hEFÃ|[gɊւf[^ --------
#define key_port porta		// L[ڑĂ|[g
int key_buff;			// L[obt@
#define sw0 0x01		// SW0 ̃|[g ۰è
#define sw1 0x02		// SW1 ̃|[g ۰è
#define RL_PORT porta		// ړ_o͂̃|[g
#define RL 3			// ړ_o
#define RL_TIME 10		// ړ_o͎ (b)


/* *************************************************************************
   ^C}荞
   ^C}荞ݎ

   TMR0 2Hz
   TMR1 64Hz
   ************************************************************************* */
#INT_CCP1	// TIMER1 CCP1 64HzŔ
LCDINT()
{
    portb ^= 0xff;		// |
    portc ^= 0xff;		// | 𗬃hCu
    portd ^= 0xff;		// |

   // ύX
   if (!(bit_test(portb,7)))	// bit7(common)  0ȂΈȉs
   {
	portb = digit0;
	portc = digit1 | colond;
	portd = digit2;
   }
}

#INT_TIMER0	// TIMER0 2Hz
TwoHertz()
{
	// 2HzŊ

	if (INT_COUNT & 0x01)
	{
	    ONE_SECOND_FLAG=TRUE;		// 1btOĂ

	    // ---------- v ----------
	    second ++;
	    if (second >= 60)			// オ菈
	    {
		second = 0;
		minute++;
		if (minute >= 60)		// オ菈
		{
		    minute = 0;
		    hour++;
		    if ((hour == contact_time0) | (hour == contact_time1))
			bit_set(RL_PORT,RL);	// ړ_Əo
		    if (hour >= 24) hour=0;	// オ菈
		}
	    }
	    if (second > RL_TIME) bit_clear(RL_PORT,RL); // ړ_o͂ر
        }

	// ---------- Ȑ ----------
	if (COLON)
	{
	    if (INT_COUNT & 0x01) colond = 0x80;
	    else colond = 0x00;
	} else colond = 0x80;			// ݒ~Ȃ_܂

	// ---------- 2Hz̲ݸ ----------
	INT_COUNT++;
}

/* *************************************************************************
   L[͊֐
   ۸т̎sɂ́Afclk=32.768kHẑƂA
   10msB́Aݸނh~̂ɕKvȎԂłB

   L[͌o@F
              --------                   --------\ 
  IN -------|D    Q|-------------------| AND    )------ OUT
      |       |      |                ---|        )
      | CLK---|CLK   |                |  --------/
      |       --------     ------     |
      ---------------------| INV  >--
                           ------

    LH́Aݸޖh~ɂ悭g@łBLH͔H
@@ƂĂ΂ĂA[qIN͂ꂽM̂AオoB
@@[qOUT́A͐M̗オ莞APɂȂB
@@{֐ key()́AL̉H\tgIɍsĂB

   key()
   ԒĺAL[̏ԂĂB
   ************************************************************************* */
int key()
{
int key_reg;
int kaeriti;
	delay_ms(10);				/* 10ms҂ */
	key_reg = KEY_PORT;
	kaeriti = (~key_reg) & key_buff;
	key_buff = key_reg;
	return(kaeriti);
}

/* *************************************************************************
   LN^֐
   int lcdgen(i)
   int i;

   iɂ́AASCIIR[hB
		'0'-'9'
	啶	'A'-'Z',
	ʲ	'-'
	ް'_'
   ɉāA
   00-0FɁA0-FĂB
   ȊÓAuNɂȂB

   ԂĺA7ZOgLEDp̃R[hB
   ************************************************************************* */
int lcdgen(int i)
{
    int kaeriti;

    switch(i)
    {
	case 0x00:	kaeriti = 0x3f;	break;	// 0
	case 0x01:	kaeriti = 0x06;	break;	// 1
	case 0x02:	kaeriti = 0x5b;	break;	// 2
	case 0x03:	kaeriti = 0x4f;	break;	// 3
	case 0x04:	kaeriti = 0x66;	break;	// 4
	case 0x05:	kaeriti = 0x6d;	break;	// 5
	case 0x06:	kaeriti = 0x7d;	break;	// 6
	case 0x07:	kaeriti = 0x27; break;	// 7
	case 0x08:	kaeriti = 0x7f; break;	// 8
	case 0x09:	kaeriti = 0x6f; break;	// 9
	case 0x0a:	kaeriti = 0x77;	break;	// A
	case 0x0b:	kaeriti = 0x7c;	break;	// b
	case 0x0c:	kaeriti = 0x58; break;	// c
	case 0x0d:	kaeriti = 0x5e; break;	// d
	case 0x0e:	kaeriti = 0x79;	break;	// E
	case 0x0f:	kaeriti = 0x71;	break;	// F
	case 'A':	kaeriti = 0x77;	break;	// A
	case 'F':	kaeriti = 0x71;	break;	// F
	case 'O':	kaeriti = 0x5c; break;	// o
	case 'N':	kaeriti = 0x54; break;	// n
	case 'P':	kaeriti = 0x73; break;	// p
	case '-':	kaeriti = 0x40;	break;	// -

	default:	kaeriti = 0x00;		// uN
    }
    return(kaeriti);
}

/* *************************************************************************
   LCD\֐
   disp(int hour, int minute)

   ************************************************************************* */
disp(int hour,int minute)
{
int h;

    h = hour & 0x0f;	// 8rbgڂAM / PM׸ނȂ̂ŁA׸ޕ
    if (h < 10)
        digit2 = lcdgen(h % 10);
        else digit2 = lcdgen(h % 10) | 0x80;
    digit1 = lcdgen(minute / 10);
    digit0 = lcdgen(minute % 10);
}

/* *************************************************************************
   ߑOǂ𔻒f֐
   boolean IsAM(int hour)
   hourߑOȂTRUEԂ
    0, 1, 2,...,11 ߑO (TRUE)
   ȊO        ߌ (FALSE)
   ************************************************************************* */
boolean IsAM(int hour)
{
    if ((0 <= hour) && (hour <= 11)) return(TRUE); else return(FALSE);
}

/* *************************************************************************
   ߌォǂ𔻒f֐
   boolean IsPM(int houra)
   houraߌȂTRUEԂ
   12,13,14,...,23 ߌ (TRUE)
   ȊO        ߑO (FALSE)
   ************************************************************************* */
boolean IsPM(int houra)
{
    if ((12 <= houra) && (houra <= 23)) return(TRUE); else return(FALSE);
}

/* *************************************************************************
   24Ԑ̎12Ԑ̎ɕϊ֐
   int Conv12h(int houra)
       0              12ɂ
       1, 2,...,11,12 ̂܂
   13,14,15,...,23    12
   ȊO           0
   ************************************************************************* */
int Conv12h(int houra)
{
int ret;

    ret = 0;
    if (houra == 0) ret = 12;
    if ((1 <= houra) && (houra <= 12)) ret = houra;
    if ((13<= houra) && (houra <= 23)) ret = houra - 12;
    return(ret);
}

/* *************************************************************************
   C֐
   ************************************************************************* */
main()
{
    int i;		// ėpϐ
    int buf;		// L[obt@

    int hour0;		// ݒ@
    int minute0;	// ݒ@

    unsigned int IntegSW1;	// XCb`1ϕJE^

    // ********** PIC16F8774߰Ċ֌W̐ݒ **********
    ADCON1 = 0x06;	// A/DްgpȂBׂިٓo
    trisa = 0x3;	// RA0,1 ́@o
    porta = 0;		// |[gAZbg
    trisb = 0;		// So
    portb = 0;		// |[gBZbg
    trisc = 0;		// So
    portc = 0;		// |[gCZbg
    trisd = 0;		// So
    portd = 0;		// |[gDZbg
    trise = 0;		// So
    porte = 0;		// |[gEZbg
    TMR0 = 0;		// Ϗݒ

    // ********** 荞݂̋ **********
    OPTION = 0x83;  	// 1000 0011b
			// bit 7   1   ߰Bٱ off
			// bit 6   0   RB0/INTœ
			// bit 2-0 011 ς̐ݒ  1/8ɐݒ
			// 32768/4/8/256=2Hz

    INTCON = 0xe0;  	// 1110 0000b
			// bit 7 : 1  SĂϽĂȂ
			// but 6 : 1  ӊgp
			// bit 5 : 1  0(TMR0)
			// bit 4 : 0  RB0/INTs
			// bit 3 : 0  RB4..7̕ωs

    setup_timer_1(T1_INTERNAL | T1_DIV_BY_8);
    setup_ccp1(CCP_COMPARE_RESET_TIMER); 
    set_timer1(0x0000);
    CCP_1 = 15;		// 64HzɂȂ悤ɐݒ  32768/4/8/16=64Hz
    enable_interrupts(INT_CCP1); 
    enable_interrupts(GLOBAL);

    trisc = 0;	// So CCP1֌WĂłȂƂ܂Ȃ

    // -------- Z --------
    // d on  sw0Ă΍Z[h
    // ߂ɂ͓d؂邵ȂB
    key_buff=0xff;	// L[obt@NA
    if (key() & sw0)	// 
    {
	digit2 = lcdgen(' ');	// | "  -"\
	digit1 = lcdgen(' ');	// |
	digit0 = lcdgen('-');	// |
	delay_ms(500);		// 0.5b炢҂
        key_buff = 0xff;	// L[obt@NA
	if (key() & sw0)
	{
	    disable_interrupts(INT_TIMER0);   // upȂ悤ϊ1֎~
	    digit2 = lcdgen('-');	// | "- --"\
	    digit1 = lcdgen('-');	// |
	    digit0 = lcdgen('-');	// |
	    for(;;) {}			// [v
	}
    }

    // -------- @ړ_̐ݒ --------
    second = 0;			// |
    minute = 0;			// |  AM 1:00.00 ɐݒ
    hour = 1;			// |
    contact_time0 = 24;		// ړ_0  off ɐݒ
    contact_time1 = 24;		// ړ_1  off ɐݒ
    COLON = TRUE;		// R\
    disp(hour,second);		// ʕ\

    // -------- 疳[v --------
    for(;;)
    {
	// -- 1bɎs ̕\ --
	if (ONE_SECOND_FLAG)
    	{
	    disp(Conv12h(hour), minute);	// \
	    ONE_SECOND_FLAG = FALSE;
	}

	// -- ȉ(ݒ) --
	buf=key();
	if (buf & sw0)	// [hݒXCb`ꂽƂ̏
	{
	    // ******** [mode0] ԍ킹 ********
	    hour0   = hour;
	    minute0 = minute;
	    IntegSW1 = 0;		// SW1ϕJE^Zbg

	    for(;;)
	    {
		i = Conv12h(hour0);
		if (i < 10) digit1 = 0; else digit1 = lcdgen(1);
		digit0 = lcdgen(i % 10);
		if (IsAM(hour0)) digit2 = lcdgen('A');
			    else digit2 = lcdgen('P');
		buf=key();
		if (buf & sw1)
		{
		    hour0++;
		    if (hour0 >= 24) hour0 = 0;
		}
		if (buf & sw0)
		{
		    hour = hour0;	//  -> Ԑݒ
		    break;
		}
	    }

	    // ******** [mode1] 킹 ********
	    digit2=0;
	    i = FALSE;		// i𕪂ݒ肵ǂ׸ނƂB
	    IntegSW1 = 0;		// SW1ϕJE^Zbg
	    for(;;)
	    {
		digit1 = lcdgen(minute0 / 10);
		digit0 = lcdgen(minute0 % 10);
		if (porta & 0x02) IntegSW1=0; else IntegSW1++; // SW1̐ϕ
		buf=key();
		if (buf & sw1)
		{
		    i = TRUE;		// ̂׸޾
		    colon = FALSE;	// R_ł~
		    minute0++;
		    if (minute0 > 59) minute0 = 0;
		}

		if (buf & sw0)
		{
		    // ĂAZbg
		    if (i == TRUE)
		    {
			colon = TRUE;		// R_ł
			minute = minute0;	//    -> ݒ
			second = 0;		// bZbg
		    }
		    break;
		}

		if (IntegSW1 > 10)	// SW11b炢ꂽƂ
		{
		    while (!(porta & 0x02))	// SW1ĂԈȉ
		    {
			i = TRUE;		// ̂׸޾
			colon = FALSE;		// ݓ_ł~
			 minute0++;
			if (minute0 > 59) minute0 = 0;
		        digit1 = lcdgen(minute0 / 10);
		        digit0 = lcdgen(minute0 % 10);
		    }
		    IntegSW1 = 0;
		}
	    }

	    // ******** [mode2] ړ_0 킹 ********
	    for(;;)
	    {

		// ݒ\
		if (contact_time0 >= 24)
		{
		    digit2 = lcdgen('-') | 0x80;
    		    digit1 = lcdgen('O');
    		    digit0 = lcdgen('F');
		}
		else
		{
    		    digit1 = lcdgen(Conv12h(contact_time0) / 10);
    		    digit0 = lcdgen(Conv12h(contact_time0) % 10);
		    if (IsAM(contact_time0)) digit2=lcdgen('A') | 0x80;
		                        else digit2=lcdgen('P') | 0x80;
		}

		buf=key();
		if (buf & sw1)
		{
		    // contact_time1  0 - 24܂ŃJEgB24offӖB
		    contact_time0 ++;
		    if (contact_time0 > 24) contact_time0 = 0;
		    i = contact_time0;
		}
		if (buf & sw0) break;
	    }

	    // ******** [mode3] ړ_1 킹 ********
	    for(;;)
	    {

		// ݒ\
		if (contact_time1 >= 24)
		{
		    digit2 = lcdgen('-') | 0x80;
    		    digit1 = lcdgen('O');
    		    digit0 = lcdgen('F');
		}
		else
		{
    		    digit1 = lcdgen(Conv12h(contact_time1) / 10);
    		    digit0 = lcdgen(Conv12h(contact_time1) % 10);
		    if (IsAM(contact_time1)) digit2=lcdgen('A') | 0x80;
		                        else digit2=lcdgen('P') | 0x80;
		}

		buf=key();
		if (buf & sw1)
		{
		    // contact_time1  0 - 24܂ŃJEgB24offӖB
		    contact_time1 ++;
		    if (contact_time1 > 24) contact_time1 = 0;
		    i = contact_time1;
		}
		if (buf & sw0) break;
	    }
	}

	// SW1ꂽƂ 5b ߑOߌ\ƕb\s
	if (buf & sw1)
	{
	    i = 0;		// \Զ
	    if (IsAM(hour)) digit2=lcdgen('A'); else digit2=lcdgen('P');
	    digit1 = lcdgen(second / 10);
	    digit0 = lcdgen(second % 10);
	    for (;;)
	    {
		if (ONE_SECOND_FLAG)
    		{
		    if (IsAM(hour)) digit2=lcdgen('A'); 
			       else digit2=lcdgen('P');
		    digit1 = lcdgen(second / 10);
		    digit0 = lcdgen(second % 10);
		    ONE_SECOND_FLAG = FALSE;
		    i++;
		}
		if (i >= 5) break; // 5b畜A
		if (key() & sw1)   // SW1ꂽ畜A
		{
		     ONE_SECOND_FLAG = TRUE;	// Ɏ\
		     break;
		}
	    }
	}
    }
}
