/* *************************************************************************
   t\ CLKB-0707s vO "1234"LCDɕ\
   sample.c

   CCS PICCRpCŃRpC

   n[hEGA:
	}CR 	PIC16F877 fclk=32.768kHz 

	LCD\ 	4a	RB0	//  |
	  SP-521    @	4b	RB1	//  |
	  		4c	RB2	//  |
			4d	RB3	//  |  1̌
			4e	RB4	//  |
	  		4f	RB5	//  |
			4g	RB6	//  |
			common	RB7	// R  32.00000Hz
	  		3a	RC0	//  |
			3b	RC1	//  |
	  		3c	RC2	//  |
			3d	RC3	//  |  10̌
			3e	RC4	//  |
	  		3f	RC5	//  |
			3g	RC6	//  |
			colon 	RC7	// R
	  		2a	RD0	//  |
			2b	RD1	//  |
	  		2c	RD2	//  |
			2d	RD3	//  |  1̌
			2e	RD4	//  |
	  		2f	RD5	//  |
			2g	RD6	//  |
			1bc     RD7	// 10̌
			
	XCb` 	SW0	RA0	// [ANeBu
	 	    @	SW1	RA1	// [ANeBu
	ý߲	TP0	RA2	// Zp
	ړ_		RL0	RA3	// nCANeBu

								200709250019

   ************************************************************************* */
#if defined(__PCM__)
#include <16F877.h>

#include <stdlib.h>

// #device ICD=TRUE		// ıĂĂȂƓsɂȂ
#fuses LP,NOWDT,NOPROTECT,NOLVP,NOBROWNOUT
#use delay(clock=32768) 	// NbNݒ
#endif

#BYTE porta = 0x5		// |[g`AhX
#BYTE portb = 0x6		// |[gaAhX
#BYTE portc = 0x7		// |[gbAhX
#BYTE portd = 0x8		// |[gcAhX
#BYTE porte = 0x9		// |[gdAhX

#BYTE trisa = 0x85		// |[g`o͐ݒAhX
#BYTE trisb = 0x86		// |[gao͐ݒAhX
#BYTE trisc = 0x87		// |[gbo͐ݒAhX
#BYTE trisd = 0x88		// |[gco͐ݒAhX
#BYTE trise = 0x89		// |[gdo͐ݒAhX

#BYTE TMR0  = 0x01		// TMR0ݒAhX
#BYTE OPTION = 0x81		// OPTIONWX^̃AhX
#BYTE INTCON = 0x0b		// INTCONWX^̃AhX
#BYTE ADCON1 = 0x9f		// ADCON1WX^̃AhX

// -------- Ŏgp郌WX^ --------
int colond;			//         LCD ăf[^

// -------- tZOgf[^ --------
int digit0;			// 1̌  LCD ăf[^
int digit1;			// 10̌ LCD ăf[^
int digit2;			// 1̌  LCD ăf[^{10̌

// -------- n[hEFÃ|[gɊւf[^ --------
#define key_port porta		// L[ڑĂ|[g
int key_buff;			// L[obt@
#define sw0 0x01		// SW0 ̃|[g ۰è
#define sw1 0x02		// SW1 ̃|[g ۰è
#define RL_PORT porta		// ړ_o͂̃|[g
#define RL 3			// ړ_o
#define RL_TIME 10		// ړ_o͎ (b)


/* *************************************************************************
   ^C}荞
   ^C}荞ݎ

   TMR1 64Hz
   ************************************************************************* */
#INT_CCP1	// TIMER1 CCP1 64HzŔ
LCDINT()
{
    portb ^= 0xff;		// |
    portc ^= 0xff;		// | 𗬃hCu
    portd ^= 0xff;		// |

   // ύX
   if (!(bit_test(portb,7)))	// bit7(common)  0ȂΈȉs
   {
	portb = digit0;
	portc = digit1 | colond;
	portd = digit2;
   }
}

/* *************************************************************************
   LN^֐
   int lcdgen(i)
   int i;

   iɂ́AASCIIR[hB
		'0'-'9'
	啶	'A'-'Z',
	ʲ	'-'
	ް'_'
   ɉāA
   00-0FɁA0-FĂB
   ȊÓAuNɂȂB

   ԂĺA7ZOgLEDp̃R[hB
   ************************************************************************* */
int lcdgen(int i)
{
    int kaeriti;

    switch(i)
    {
	case 0x00:	kaeriti = 0x3f;	break;	// 0
	case 0x01:	kaeriti = 0x06;	break;	// 1
	case 0x02:	kaeriti = 0x5b;	break;	// 2
	case 0x03:	kaeriti = 0x4f;	break;	// 3
	case 0x04:	kaeriti = 0x66;	break;	// 4
	case 0x05:	kaeriti = 0x6d;	break;	// 5
	case 0x06:	kaeriti = 0x7d;	break;	// 6
	case 0x07:	kaeriti = 0x27; break;	// 7
	case 0x08:	kaeriti = 0x7f; break;	// 8
	case 0x09:	kaeriti = 0x6f; break;	// 9
	case 0x0a:	kaeriti = 0x77;	break;	// A
	case 0x0b:	kaeriti = 0x7c;	break;	// b
	case 0x0c:	kaeriti = 0x58; break;	// c
	case 0x0d:	kaeriti = 0x5e; break;	// d
	case 0x0e:	kaeriti = 0x79;	break;	// E
	case 0x0f:	kaeriti = 0x71;	break;	// F
	case 'A':	kaeriti = 0x77;	break;	// A
	case 'F':	kaeriti = 0x71;	break;	// F
	case 'O':	kaeriti = 0x5c; break;	// o
	case 'N':	kaeriti = 0x54; break;	// n
	case 'P':	kaeriti = 0x73; break;	// p
	case '-':	kaeriti = 0x40;	break;	// -

	default:	kaeriti = 0x00;		// uN
    }
    return(kaeriti);
}

/* *************************************************************************
   C֐
   ************************************************************************* */
main()
{
    int i;		// ėpϐ
    int buf;		// L[obt@

    // ********** PIC16F8774߰Ċ֌W̐ݒ **********
    ADCON1 = 0x06;	// A/DްgpȂBׂިٓo
    trisa = 0x3;	// RA0,1 ́@o
    porta = 0;		// |[gAZbg
    trisb = 0;		// So
    portb = 0;		// |[gBZbg
    trisc = 0;		// So
    portc = 0;		// |[gCZbg
    trisd = 0;		// So
    portd = 0;		// |[gDZbg
    trise = 0;		// So
    porte = 0;		// |[gEZbg

    // ********** 荞݂̋ **********
    OPTION = 0x83;  	// 1000 0011b
			// bit 7   1   ߰Bٱ off
			// bit 6   0   RB0/INTœ
			// bit 2-0 011 ς̐ݒ  1/8ɐݒ
			// 32768/4/8/256=2Hz

    INTCON = 0xc0;  	// 1100 0000b
			// bit 7 : 1  SĂϽĂȂ
			// but 6 : 1  ӊgp
			// bit 5 : 0  0(TMR0)s
			// bit 4 : 0  RB0/INTs
			// bit 3 : 0  RB4..7̕ωs

    setup_timer_1(T1_INTERNAL | T1_DIV_BY_8);
    setup_ccp1(CCP_COMPARE_RESET_TIMER); 
    set_timer1(0x0000);
    CCP_1 = 15;		// 64HzɂȂ悤ɐݒ  32768/4/8/16=64Hz
    enable_interrupts(INT_CCP1); 
    enable_interrupts(GLOBAL);

    trisc = 0;	// So CCP1֌WĂłȂƂ܂Ȃ

    colond = 0;			// | R_łȂ
    digit2 = lcdgen(2) | 0x80;	// |
    digit1 = lcdgen(3);		// | "1234"\
    digit0 = lcdgen(4);		// |

    // -------- 疳[v --------
    for(;;) {}
}
